﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using Stimulsoft.Report;
using System.Data;
using System.IO;

namespace StimulsoftReportDesigner.Web
{
    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the class name "Service1" in code, svc and config file together.
    public class Service1 : IService1
    {
        public string DoWork()
        {
            string reportDefXml;
            // CREATE NEW REPORT AND BIND SCHEMA
            StiReport stiReport = new StiReport();
            string appDir = Environment.CurrentDirectory;
            DataSet data = new DataSet();
            DataTable dt = new DataTable();
            dt.Columns.Add("Col1");
            DataRow dr = dt.NewRow();
            dr[0] = "Nitin";
            dt.Rows.Add(dr);
            data.Tables.Add(dt);
            // THIS XSD FILE WILL BE DYNAMICALLY GENERATED, BUT I AM USING YOUR SAMPLE DEMO ONE FOR MY PROTOTYPE.
            //data.ReadXmlSchema(appDir + "\\Demo.xsd");
            //data.ReadXml(appDir + "\\Demo.xml");
            //data.DataSetName = "Demo";
            stiReport.RegData(data);
            stiReport.Dictionary.Synchronize();

            // SAVE REPORT TO STREAM 
            using (MemoryStream ms = new MemoryStream())
            {
                stiReport.Save(ms);
                ms.Position = 0;
                StreamReader sr = new StreamReader(ms);
                reportDefXml = sr.ReadToEnd();
            }

            // SEND reportDefXml TO SILVERLIGHT CLIENT
            return reportDefXml;
        }

        public DataSet GetData()
        {
            DataSet data = new DataSet();
            DataTable dt = new DataTable();
            dt.Columns.Add("Col1");
            dt.Columns.Add("Col2");
            DataRow dr = dt.NewRow();
            dr[0] = "Nitin";
            dt.Rows.Add(dr);
            data.Tables.Add(dt);
            return data;
        }

        public string GetData2()
        {

            MyDataSet d = new MyDataSet();
            d.DataCol = "Col1";
            d.DataCol2 = "Col2";
            List<MyDataSet> l = new List<MyDataSet>();
            l.Add(d);
            d = new MyDataSet();
            d.DataCol = "Col 2";
            l.Add(d);
           
            string reportDefXml;
            // CREATE NEW REPORT AND BIND SCHEMA
            StiReport stiReport = new StiReport();

            stiReport.RegBusinessObject("NewName", "Test", l);
            stiReport.Dictionary.Synchronize();

            // SAVE REPORT TO STREAM 
            using (MemoryStream ms = new MemoryStream())
            {
                stiReport.Save(ms);
                ms.Position = 0;
                StreamReader sr = new StreamReader(ms);
                reportDefXml = sr.ReadToEnd();
            }

            // SEND reportDefXml TO SILVERLIGHT CLIENT
            return reportDefXml;
        }

        public List<MyDataSet> GetListData()
        {
            MyDataSet d = new MyDataSet();
            d.DataCol = "Col11";
            d.DataCol2 = "Col12";
            List<MyDataSet> l = new List<MyDataSet>();
            l.Add(d);
            d = new MyDataSet();
            d.DataCol = "Col 21";
            d.DataCol2 = "Col 22";
            l.Add(d);
            return l;
        }
    }

    [DataContract]
    public class MyDataSet
    {
        [DataMember]
        public string DataCol { get; set; }

        [DataMember]
        public string DataCol2 { get; set; }
    }
}
